unit uDecisionMatrixDemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,
  uDecisionMatrix, StdCtrls, ExtCtrls, ImgList, jpeg, Grids;

type
  TfrmDecisionMatrix = class(TForm)
    btnClose: TButton;
    rgUserType: TRadioGroup;
    rgFunction: TRadioGroup;
    Image1: TImage;
    pnlRedGreen: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnCloseClick(Sender: TObject);
    procedure RGClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    UFMatrix: TDecisionMatrix;
  public
    { Public declarations }
  end;

var
  frmDecisionMatrix: TfrmDecisionMatrix;

implementation

{$R *.dfm}

procedure TfrmDecisionMatrix.FormCreate(Sender: TObject);
begin
  UFMatrix := TDecisionMatrix.Create;

  UFMatrix.DefaultResult := False;
  UFMatrix.SetResult('Guest', 'Read Data', True);
  UFMatrix.SetResult('Data', 'Sign In', True);
  UFMatrix.SetResult('Data', 'Read Data', True);
  UFMatrix.SetResult('Data', 'Update Data', True);
  UFMatrix.SetResult('Admin', 'Sign In', True);
  UFMatrix.SetResult('Admin', 'Read Data', True);
  UFMatrix.SetResult('Admin', 'Administer Users', True);
  UFMatrix.SetResult('System', 'Sign In', True);
  UFMatrix.SetResult('System', 'Administer Users', True);
  UFMatrix.SetResult('System', 'Update System', True);
end;

procedure TfrmDecisionMatrix.FormShow(Sender: TObject);
begin
  RGClick(Self);
end;

procedure TfrmDecisionMatrix.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  UFMatrix.Free;
end;

procedure TfrmDecisionMatrix.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmDecisionMatrix.RGClick(Sender: TObject);
var
  UserType: string;
  FunctionType: string;
begin
  with rgUserType do
    UserType := Items[ItemIndex];
  with rgFunction do
    FunctionType := Items[ItemIndex];
  if UFMatrix.CheckResult(UserType, FunctionType) then
    pnlRedGreen.Color := clLime
  else
    pnlRedGreen.Color := clRed;
end;

end.
